/****************************************************
*
*     PROYECTO: XbpBrowseDragDrop
*     ARCHIVOS: DragBro.prg, DragBro.ch, DragBro.arc, ;
*               Sin.ico, Puntero.ico
*
*  Programador: J.A. Diego Kerejeta
*       Creado: 18/09/03
*      Version: 1.0
*
******************************************************/


#include "Appevent.ch"
#include "Directry.ch"
#include "Common.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include 'dll.ch'
#include 'dragbro.ch'

#pragma Library( "XppUi2.lib" )

#define COL_SELECTOR_SIN         0
#define COL_SELECTOR_FILAS       1
#define COL_SELECTOR_COLUMNAS    2 

#xtrans  PRESPARAM_BRO  => {;
         { XBP_PP_COL_DA_FGCLR            , GRA_CLR_BLACK                   }, ;
         { XBP_PP_COL_DA_BGCLR            , COLOR_BG_TABLA                  }, ;
         { XBP_PP_COL_DA_COMPOUNDNAME     , FONT_BASE                       }, ;
         { XBP_PP_COL_DA_ROWSEPARATOR     , XBPLINE_NONE                    }, ;
         { XBP_PP_COL_DA_COLSEPARATOR     , XBPLINE_NONE                    }, ;
         { XBP_PP_COL_DA_FRAMELAYOUT      , XBPFRAME_NONE                   }, ;
         { XBP_PP_COL_DA_CELLFRAMELAYOUT  , XBPFRAME_BOX + XBPFRAME_RAISED  }, ;
         { XBP_PP_COL_DA_HILITEFRAMELAYOUT, XBPFRAME_NONE                   }, ;
         { XBP_PP_COL_DA_HILITE_FGCLR     , GRA_CLR_BLACK                   }, ;
         { XBP_PP_COL_DA_HILITE_BGCLR     , COLOR_BG_ROWTABLA               }, ;
         { XBP_PP_COL_HA_COMPOUNDNAME     , '7.Arial Bold'                  }, ;
         { XBP_PP_COL_HA_FGCLR            , COLOR_FG_CABTABLA               }, ;
         { XBP_PP_COL_HA_BGCLR            , COLOR_BG_CABTABLA               } }


#define FONT_BASE 			  "8.Arial"

#define COLOR_BG_ROWTABLA   GraMakeRGBcolor( { 249, 234, 181 } )
#define COLOR_BG_TABLA      GraMakeRGBcolor( { 255, 255, 239 } )
#define COLOR_BG_CABTABLA   GraMakeRGBcolor( {   0,   0, 160 } )
#define COLOR_FG_CABTABLA   GraMakeRGBcolor( { 255, 255, 198 } )
#define COLOR_BG_SELECTOR   GraMakeRGBcolor( { 207, 220, 236 } )
#define COLOR_FG_SELECTOR   GRA_CLR_BLACK

#define SM_CXVSCROLL            2
#define SM_CYHSCROLL            3

DLLFUNCTION GetSystemMetrics( nIndex ) USING STDCALL FROM user32.dll

***************************************************
***************************************************
CLASS XbpBrowseDragDrop FROM XbpBrowse, DragAndDrop
***************************************************
***************************************************
PROTECTED:
   INLINE METHOD getRect( aPos )
   *****************************
      LOCAL nFila:= ::oColumnaActiva:dataArea:cellFromPos( aPos )
      LOCAL nX1, nX2, nY1, nY2, nCont, oTmp, nColorBG, nColorFG

      ::oColumnaActiva:dataArea:getCellColor( nFila,, @nColorBG )

      IF nColorBG <> ::nColorBGselec
         RETURN nil
      ENDIF
      ::refreshCurrent()

      IF ::nTipoSelector == COL_SELECTOR_FILAS
         nX1:= GetPosAbsoluta( self )[ 1 ]
         nX2:= nX1 + ::currentSize()[ 1 ] - IIF( ::vScroll, GetSystemMetrics( SM_CXVSCROLL ), 0 )
      ELSE
         FOR nCont:= 1 TO ::colCount
            oTmp:= ::getColumn( nCont ):dataArea
            oTmp:getCellColor( nFila,, @nColorBG )
    
            IF nColorBG = ::nColorBGselec
               IF nX1 = nil
                  nX1:= Max( GetPosAbsoluta( oTmp )[ 1 ], GetPosAbsoluta( self )[ 1 ] + 3 )
               ENDIF
            ELSEIF nX1 <> nil
               nX2:= Min( GetPosAbsoluta( oTmp )[ 1 ] - 1, ;
                          GetPosAbsoluta( self )[ 1 ] + ::currentSize()[ 1 ] - IIF( ::vScroll, GetSystemMetrics( SM_CXVSCROLL ), 0 ) )
               EXIT
            ENDIF
         NEXT
         IF nX2 = NIL
            nX2:= GetPosAbsoluta( self )[ 1 ] + ::currentSize()[ 1 ] - IIF( ::vScroll, GetSystemMetrics( SM_CXVSCROLL ), 0 )
         ENDIF
      ENDIF
      FOR nCont:= 1 TO ::rowCount
         ::oColumnaActiva:dataArea:getCellColor( nCont,, @nColorBG )
          
         IF nColorBG = ::nColorBGselec
            IF nY2 = nil
               nY2:= GetPosAbsoluta( ::oColumnaActiva:dataArea )[ 2 ] + ::oColumnaActiva:dataArea:cellRect( nCont )[ 4 ]
            ENDIF
         ELSEIF nY2 <> nil
            nY1:= GetPosAbsoluta( ::oColumnaActiva:dataArea )[ 2 ] + ::oColumnaActiva:dataArea:cellRect( nCont )[ 4 ] + 1
            EXIT
         ENDIF
      NEXT
      IF nY1 = nil
         nY1:= GetPosAbsoluta( ::oColumnaActiva:dataArea )[ 2 ]
      ENDIF
      aPos:= GetPosAbsoluta( self )
   RETURN { nX1, nY1, nX2, nY2, { nX1 - aPos[ 1 ], nY1 - aPos[ 2 ], nX2 - aPos[ 1 ], nY2 - aPos[ 2 ] } }

EXPORTED:
   VAR _cursorMode
   VAR nFila
   VAR aRecnos
   VAR aCols
   VAR nCol
   VAR oColumnaActiva
   VAR nTipoSelector
   VAR nColorBGselec
   VAR DBF
 
   INLINE METHOD init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::DragAndDrop:init()
      ::XbpBrowse:init( oParent, oOwner, aPos, aSize, IIF( aPP = nil, PRESPARAM_BRO, aPP ) )
      ::DBF           := select()
      ::skipBlock     := {|n| ::DBFSkipper( n )                }
      ::goTopBlock    := {| | ( ::DBF )->( DbGoTop()         ) }
      ::goBottomBlock := {| | ( ::DBF )->( DbGoBottom()      ) }
      ::phyPosBlock   := {| | ( ::DBF )->( Recno()           ) }

      ::posBlock      := {| | ( ::DBF )->( DbPosition()      ) }
      ::goPosBlock    := {|n| ( ::DBF )->( DbGoPosition( n ) ) } 
      ::lastPosBlock  := {| | 100             }
      ::firstPosBlock := {| | 0               }
      ::cursorMode    := XBPBRW_CURSOR_ROW 
      ::nTipoSelector := COL_SELECTOR_FILAS
      ::nColorBGselec := COLOR_BG_SELECTOR
   RETURN self

   INLINE METHOD create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *******************************************************************
      ::_cursorMode:= ::cursorMode
   RETURN ::XbpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   INLINE METHOD destroy
   *********************
      ::DragAndDrop:destroy()
      ::XbpBrowse:destroy()
      ::aRecnos := ::aCols := ::nFila:= ::nCol:= ;
      ::oColumnaActiva:= ::nTipoSelector:= ::DBF:= nil
   RETURN self

   INLINE METHOD DBFskipper( nWantSkip )
   *************************************
      LOCAL nDidSkip := 0 
 
      DO CASE 
         CASE ( ::DBF )->( LastRec() ) == 0
         CASE nWantSkip == 0 
            ( ::DBF )->( DBgoTo( ( ::DBF )->( RecNo() ) ) )
         CASE nWantSkip > 0
            DO WHILE nWantSkip > nDidSkip .AND. .NOT. ( ::DBF )->( Eof() )
               ( ::DBF )->( DBskip() )
               IF ( ::DBF )->( Eof() )
                  ( ::DBF )->( DBskip( -1 ) )
                  EXIT 
               ENDIF 
               nDidSkip ++ 
            ENDDO 
         CASE nWantSkip < 0
            DO WHILE nWantSkip < nDidSkip .AND. .NOT. ( ::DBF )->( Bof() )
               ( ::DBF )->( DBskip( -1 ) )
               IF ( ::DBF )->( Bof() )
                  EXIT 
               ENDIF 
               nDidSkip -- 
            ENDDO 
      ENDCASE 
  RETURN nDidSkip

  INLINE METHOD ColorBlock( bColorBlock )
  ***************************************
     LOCAL nCont
     DEFAULT bColorBlock TO {|| { nil, nil } }

     FOR nCont:= 1 TO ::colCount
        ::getColumn( nCont ):colorBlock:= bColorBlock
     NEXT
  RETURN self

  INLINE METHOD desactivaMarcados
  *******************************
     IF ::aRecnos <> NIL
        ::nFila  := NIL
        ::aRecnos:= NIL
        ::aCols  := NIL
        ::colorBlock( NIL )
        ::forceStable()
        ::refreshAll()
     ENDIF
  RETURN self
ENDCLASS

**************************************
**************************************
CLASS XbpColumnDragDrop FROM XbpColumn
**************************************
**************************************
PROTECTED:
   VAR nRetardo

EXPORTED:
   VAR oBrowse
   VAR DBF
   VAR aColorEstandar 

   METHOD init, create
   METHOD _lbDown, _lbUp, _motion

   INLINE METHOD destroy
   *********************
     ::XbpColumn:destroy()
     ::oBrowse:= ::DBF:= ::aColorEstandar := nil
   RETURN self
ENDCLASS

****************************************************************************
METHOD XbpColumnDragDrop:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
****************************************************************************
::XbpColumn:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

IF oParent <> NIL
   ::oBrowse := oParent
ENDIF
::DBF           := select()
::nRetardo      := 0
RETURN self

******************************************************************************
METHOD XbpColumnDragDrop:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
******************************************************************************
LOCAL oError

::XbpColumn:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

IF ::oBrowse == NIL
   ::oBrowse := oParent
ENDIF
IF ::oBrowse:nTipoSelector <> COL_SELECTOR_SIN
   ::dataArea:lbDown := {|aPos| ::_lbDown( aPos ) }
   ::dataArea:lbUp   := {|aPos| ::_lbUp( aPos ) }
   ::dataArea:motion := {|aPos| ::_motion( aPos ) }
   ::aColorEstandar  := { ::setColorFG(), ::setColorBG() }
ENDIF
RETURN self

****************************************
METHOD XbpColumnDragDrop:_lbDown( aPos )
****************************************
::oBrowse:oColumnaActiva := self
IF ::oBrowse:aRecnos <> NIL
   IF ::oBrowse:drag( aPos )
      RETURN self
   ENDIF
   ::oBrowse:aRecnos := NIL
   ::oBrowse:aCols   := NIL
   ::oBrowse:colorBlock( NIL )
   ::oBrowse:forceStable()
   ::oBrowse:refreshAll()
ENDIF
::oBrowse:nFila := ::dataArea:cellFromPos( aPos )
::nRetardo      := 0
RETURN self

**************************************
METHOD XbpColumnDragDrop:_lbUp( aPos )
**************************************
::oBrowse:nFila  := NIL
::oBrowse:nCol   := NIL

IF ::oBrowse:aRecnos <> NIL
   ::oBrowse:cursorMode := ::oBrowse:_cursorMode
   ::oBrowse:forceStable()
   ::oBrowse:refreshCurrent()
   ::oBrowse:setPointer( , XBPSTATIC_SYSICON_ARROW, ;
                                    XBPWINDOW_POINTERTYPE_SYSPOINTER )
   ::oBrowse:oColumnaActiva:dataArea:captureMouse( .F. ) 
ENDIF
RETURN self

****************************************
METHOD XbpColumnDragDrop:_Motion( aPos )
****************************************
LOCAL nFilaTmp, nMarcados, oCol, nCont

IF ::oBrowse:nFila == NIL .OR. ++::nRetardo < 3
   RETURN self
ELSEIF ::oBrowse:aRecnos == NIL
  ::oBrowse:setPointer( , XBPSTATIC_SYSICON_SIZE, ;
                                       XBPWINDOW_POINTERTYPE_SYSPOINTER )
  ::dataArea:captureMouse( .T. ) 

  ::oBrowse:forceStable()
  ::oBrowse:oColumnaActiva := self
  ::oBrowse:aRecnos:= { ( ::DBF )->( Recno() ) }
  ::oBrowse:nCol := ::oBrowse:colPos

  IF ::oBrowse:cursorMode == XBPBRW_CURSOR_ROW ;    // correccion del valor 
         .AND. ::oBrowse:nFila == ::oBrowse:rowPos  // colPos. Parece un error
     FOR nCont:= 1 TO ::oBrowse:colCount            // del XbpBrowse
        IF ::oBrowse:getColumn( nCont ) == self
           ::oBrowse:nCol:= nCont
           EXIT
        ENDIF
      NEXT
  ENDIF
  ::oBrowse:aCols  := { ::oBrowse:nCol }

  IF ::oBrowse:nTipoSelector == COL_SELECTOR_FILAS
     ::oBrowse:colorBlock( {|x| IIF( ::oBrowse:aRecnos = NIL ;
                        .OR. ASCAN( ::oBrowse:aRecnos, ( ::DBF )->( Recno() ) ) = 0,;
                        ::aColorEstandar, { COLOR_FG_SELECTOR, ;
                        ::oBrowse:nColorBGselec } ) } )
  ELSE
     ::colorBlock     := {|x| IIF( ::oBrowse:aRecnos = NIL ;
                         .OR. ASCAN( ::oBrowse:aRecnos, ( ::DBF )->( Recno() ) ) = 0,;
                         ::aColorEstandar, { COLOR_FG_SELECTOR, ;
                         ::oBrowse:nColorBGselec } ) }
  ENDIF
  ::oBrowse:dehilite()
  ::oBrowse:cursorMode:= XBPBRW_CURSOR_NONE
  ::oBrowse:refreshCurrent()
ENDIF

nFilaTmp := ::dataArea:cellFromPos( aPos )

IF nFilaTmp > ::oBrowse:nFila .OR. aPos[ 2 ] < 0
   ::oBrowse:Down():forceStable()
   IF ASCAN( ::oBrowse:aRecnos, ( ::DBF )->( Recno() ) ) = 0
      AADD( ::oBrowse:aRecnos, ( ::DBF )->( Recno() ) )
      ::oBrowse:nFila:= nFilaTmp
      ::oBrowse:refreshCurrent()
   ENDIF
ELSEIF  ( nMarcados:= LEN( ::oBrowse:aRecnos ) ) > 1 .AND. ;
        ( nFilaTmp < ::oBrowse:nFila .OR. aPos[ 2 ] > ::dataArea:currentSize()[ 2 ] )
   ASIZE( ::oBrowse:aRecnos, nMarcados - 1 )
   ::oBrowse:refreshCurrent()
   ::oBrowse:Up():forceStable()
   ::oBrowse:nFila:= nFilaTmp
ENDIF

IF aPos[ 1 ] > ::oBrowse:oColumnaActiva:currentSize()[ 1 ]
   IF ::oBrowse:nCol < ::oBrowse:colCount .AND. ASCAN( ::oBrowse:aCols, ::oBrowse:nCol + 1 ) = 0
      ::oBrowse:nCol += 1
      ::oBrowse:oColumnaActiva:= ::oBrowse:getColumn( ::oBrowse:nCol )
      ::oBrowse:oColumnaActiva:dataArea:captureMouse( .T. )

      AADD( ::oBrowse:aCols, ::oBrowse:nCol )

      IF ::oBrowse:nTipoSelector <> COL_SELECTOR_FILAS
         ::oBrowse:oColumnaActiva:colorBlock:= {|x| IIF( ::oBrowse:aRecnos = NIL ;
                          .OR. ASCAN( ::oBrowse:aRecnos, ( ::DBF )->( Recno() ) ) = 0,;
                          ::aColorEstandar, { COLOR_FG_SELECTOR, ;
                          ::oBrowse:nColorBGselec } ) }
         ::oBrowse:right():forceStable()
         ::oBrowse:refreshAll()
      ELSE
      ENDIF
   ENDIF
ELSEIF aPos[ 1 ] < 0 .AND. ( nMarcados:= LEN( ::oBrowse:aCols ) ) > 1
   ::oBrowse:nCol -= 1
   ::oBrowse:oColumnaActiva:= ::oBrowse:getColumn( ::oBrowse:nCol )
   ::oBrowse:oColumnaActiva:dataArea:captureMouse( .T. )

   ASIZE( ::oBrowse:aCols, nMarcados - 1 )

   IF ::oBrowse:nTipoSelector <> COL_SELECTOR_FILAS
      oCol:= ::oBrowse:getColumn( ::oBrowse:nCol + 1 )
      oCol:colorBlock:= {|| ::aColorEstandar }
      ::oBrowse:left():forceStable()
      ::oBrowse:refreshAll()
      oCol:colorBlock:= NIL
   ELSE
      ::oBrowse:left():forceStable()
   ENDIF
ENDIF
*sleep( 0.1 )
RETURN self

*****************
*****************
CLASS DragAndDrop
*****************
*****************
PROTECTED:
   VAR aRegistrados

   INLINE METHOD getRect
   *********************
   RETURN { 0, 0, 0, 0, { 0, 0, 0, 0 } }

   INLINE METHOD PaintDrop( oDragArea )
   ************************************
      LOCAL aSize := oDragArea:currentSize()
      LOCAL nIndiMax, nIndiMin, nRatio

      IF aSize[ 1 ] > aSize[ 2 ]
         nIndiMax:= 1 ;     nIndiMin:= 2
      ELSE
         nIndiMax:= 2 ;     nIndiMin:= 1
      ENDIF
      nRatio := Max( Int( aSize[ nIndiMax ] / 10 ), 1 )
      DO WHILE aSize[ nIndiMax ] > aSize[ nIndiMin ]
         aSize[ nIndiMax ] -= nRatio
         oDragArea:setSize( aSize )
         Sleep( 0.1 )
      ENDDO
      aSize[ nIndiMax ]:= aSize[ nIndiMin ]
      DO WHILE aSize[ 1 ] > nRatio
         aSize[ 1 ] -= nRatio
         aSize[ 2 ] -= nRatio
         oDragArea:setSize( aSize )
         Sleep( 0.1 )
      ENDDO
   RETURN

EXPORTED:
   VAR oDlgParent

   INLINE METHOD destroy
   *********************
     ::aRegistrados:= nil
   RETURN self

   INLINE METHOD drag( aPos )
   **************************
      LOCAL oDragArea, nEvent, mp1, mp2, oXbp, nRetardo, aRectReg
      LOCAL oPunt, nDifX, nDifY, nCont, nCursor, aPosDragArea, nContDlgRegs
      LOCAL nNumDlgRegs, nNumXbpRegs, aDlgParentRect, nPosDlgParent
      LOCAL nPosXbpIni, nPosXbpFin, aPosReceptor
      LOCAL nUltimoCursor := -1
      LOCAL aRect         := ::getRect( aPos )
 
      IF aRect = nil
         RETURN .F.
      ELSEIF ::oDlgParent = nil
         ::oDlgParent:= ::setparent()
         DO WHILE ! ::oDlgParent:isDerivedFrom( 'XbpDialog' )
            ::oDlgParent := ::oDlgParent:setParent()
         ENDDO
         IF ::aRegistrados = nil
            ::aRegistrados := {}
         ENDIF
      ENDIF

      oDragArea:= XbpDialog():new( AppDeskTop(), SetAppWindow(), { aRect[ 1 ], aRect[ 2 ] }, ;
                                   { aRect[ 3 ] - aRect[ 1 ], aRect[ 4 ] - aRect[ 2 ] },, .F. )
         oDragArea:border:= XBPDLG_NO_BORDER
         oDragArea:titleBar:= .F.
         oDragArea:drawingArea:bitmap:= BitDragArea( self, aRect[ 5 ] )
         oDragArea:alwaysOnTop:= .T.
         oDragArea:create():captureMouse( .T. )

      oXbp:= XbpStatic():new()
         oXbp:type     := XBPSTATIC_TYPE_ICON
         oXbp:caption  := ICONO_DRAGDROP_PUNTERO
         oXbp:create( oDragArea:drawingArea,, { 1, 1 }, { 16, 16 }, ;
                         { { XBP_PP_FGCLR, XBPSYSCLR_TRANSPARENT }, ;
                           { XBP_PP_BGCLR, XBPSYSCLR_TRANSPARENT } } )

      nNumDlgRegs:= LEN( ::aRegistrados )
      nRetardo   := 0

      DO WHILE .T.
      	 nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:handleEvent( nEvent, mp1, mp2 )

         IF nEvent == xbeM_Motion 
            IF oXbp = oDragArea
               IF ++nRetardo < 4
                  LOOP
               ELSEIF nDifX = nil
                  oDragArea:show()

                  IF ( nDifX := Min( mp1[ 1 ], oDragArea:CurrentSize()[ 1 ] - 3 ) ) < 3
                     nDifX:= 3
                  ENDIF

                  IF ( nDifY := Min( mp1[ 2 ], oDragArea:CurrentSize()[ 2 ] - 3 ) ) < 3
                     nDifY:= 3
                  ENDIF

                  aDlgParentRect := GetRectAbsoluta( ::oDlgParent )
                  nPosDlgParent  := ASCAN( ::aRegistrados, {|aR| aR[ 1 ] = ::oDlgParent } )
                  aPosDragArea   := oDragArea:currentPos()

               ENDIF
               aPosDragArea[ 1 ] += mp1[ 1 ] - nDifX
               aPosDragArea[ 2 ] += mp1[ 2 ] - nDifY
               oDragArea:setPos( aPosDragArea )

               nCursor:= ICONO_DRAGDROP_SIN_RECEPTOR

               IF aPosDragArea[ 1 ] >= aDlgParentRect[ 1 ]  ;
                            .AND. aPosDragArea[ 2 ] >= aDlgParentRect[ 2 ] ;
                            .AND. aPosDragArea[ 1 ] <= aDlgParentRect[ 3 ] ;
                            .AND. aPosDragArea[ 2 ] <= aDlgParentRect[ 4 ]
                  nPosXbpIni:= nPosDlgParent
                  nPosXbpFin:= IIF( nPosDlgParent = 0, -1, nPosDlgParent )

                  IF ! ::oDlgParent:hasInputFocus()
                     SetAppFocus( ::oDlgParent )
                  ENDIF
               ELSE
                  nPosXbpIni:= 1
                  nPosXbpFin:= nNumDlgRegs
               ENDIF
               aPosReceptor:= nil

               FOR nContDlgRegs:= nPosXbpIni TO nPosXbpFin

                  nNumXbpRegs:= LEN( ::aRegistrados[ nContDlgRegs ] )
 
                  FOR nCont:= 2 TO nNumXbpRegs
                      oPunt  := ::aRegistrados[ nContDlgRegs, nCont, 1 ]
                      aRectReg := GetRectAbsoluta( oPunt )

                      IF aPosDragArea[ 1 ] >= aRectReg[ 1 ]  ;
                            .AND. aPosDragArea[ 2 ] >= aRectReg[ 2 ] ;
                            .AND. aPosDragArea[ 1 ] <= aRectReg[ 3 ] ;
                            .AND. aPosDragArea[ 2 ] <= aRectReg[ 4 ]

                          IF ! ::aRegistrados[ nContDlgRegs, 1 ]:hasInputFocus()
                             SetAppFocus( ::aRegistrados[ nContDlgRegs, 1 ] )
                          ENDIF

                          nCursor:= XBPSTATIC_SYSICON_ARROW
                          IF ::aRegistrados[ nContDlgRegs, nCont, 3 ] <> nil
                             EVAL( ::aRegistrados[ nContDlgRegs, nCont, 3 ], oPunt, aPosDragArea )
                          ENDIF
                          aPosReceptor:= { nContDlgRegs, nCont }
                          nContDlgRegs:= 99999
                        ENDIF
                     NEXT
                 NEXT
                 IF nCursor <> nUltimoCursor
                    oDragArea:drawingArea:setPointer( , nCursor, XBPWINDOW_POINTERTYPE_ICON )
                    nUltimoCursor:= nCursor
                 ENDIF
              ENDIF
      	ELSEIF nEvent == xbeM_LbUp
            IF aPosDragArea <>  nil .AND. aPosReceptor <> nil .AND. nCursor == XBPSTATIC_SYSICON_ARROW
               IF ::aRegistrados[ aPosReceptor[ 1 ], aPosReceptor[ 2 ], 2 ] <> nil
                  ::PaintDrop( oDragArea )
                  EVAL( ::aRegistrados[ aPosReceptor[ 1 ], aPosReceptor[ 2 ], 2 ], self, ;
                        ::aRegistrados[ aPosReceptor[ 1 ], aPosReceptor[ 2 ], 1 ] )
               ENDIF
            ENDIF
            EXIT
         ENDIF
         Sleep( 0.1 )
      ENDDO
      oDragArea:captureMouse( .F. )
      oDragArea:destroy()                   
   RETURN .T.

   INLINE METHOD registraReceptor( oXbp, bDrop, bDrag )
   ****************************************************
      LOCAL oDlgParent := oXbp:setParent()
      LOCAL nPos

      DO WHILE ! oDlgParent:isDerivedFrom( 'XbpDialog' )
         oDlgParent := oDlgParent:setParent()
      ENDDO
      IF ::aRegistrados = nil 
         ::aRegistrados:= {}
         AADD( ::aRegistrados, { oDlgParent, { oXbp, bDrop, bDrag } } )
      ELSE
         nPos:= ASCAN( ::aRegistrados, {|aR| aR[ 1 ] = oDlgParent } )
         IIF( nPos = 0, AADD( ::aRegistrados, { oDlgParent, { oXbp, bDrop, bDrag } } ), ;
                        AADD( ::aRegistrados[ nPos ], { oXbp, bDrop, bDrag } ) )
      ENDIF
   RETURN ::aRegistrados

   INLINE METHOD eliminaReceptor( oXbp )
   *************************************
      LOCAL nFin:= LEN( ::aRegistrados )
      LOCAL nCont, nPos, nNum

      FOR nCont:= 1 TO nFin
         nPos:= ASCAN( ::aRegistrados[ nCont ], {|aR| aR[ 1 ] = oXbp }, 2 )
         IF nPos <> 0
            nNum:= LEN( ::aRegistrados[ nCont ] )
            IF nNum > 2 
               ADEL( ::aRegistrados[ nCont ], nPos )
               ASIZE( ::aRegistrados[ nCont ], nNum - 1 )
            ELSE
               ADEL( ::aRegistrados, nCont ) 
               ASIZE( ::aRegistrados, nFin - 1 )
            ENDIF
         ENDIF
      NEXT
   RETURN ::aRegistrados
ENDCLASS

*************************************************
STATIC FUNCTION BitDragArea( oSourceArea, aRect )
*************************************************
LOCAL oTargetPS := XbpPresSpace():new():create() 
LOCAL oBitmap   := XbpBitmap():new():create()
LOCAL oPS       := oSourceArea:lockPS()
LOCAL nSizeX    := aRect[ 3 ] - aRect[ 1 ]
LOCAL nSizeY    := aRect[ 4 ] - aRect[ 2 ]

oBitmap:presSpace( oTargetPS ) 
oBitmap:make( nSizeX, nSizeY ) 
GraBitBlt( oTargetPS, oPS, { 0, 0, nSizeX, nSizeY }, aRect )
oSourceArea:unLockPS( oPS )
oTargetPS:destroy()
RETURN oBitmap

********************************
FUNCTION GetRectAbsoluta( oXbp )
********************************
LOCAL cBuffer   := Space(16)
LOCAL nYDeskTop := AppDeskTop():currentSize()[ 2 ]

DllCall("User32.DLL", DLL_STDCALL,"GetWindowRect", oXbp:GetHwnd(), @cBuffer)
RETURN { Bin2U( left( cBuffer, 4 ) ), ;
         nYDeskTop - Bin2U( substr( cBuffer, 13, 4 ) ), ;
         Bin2U( substr( cBuffer,  9, 4 ) ), ;
         nYDeskTop - Bin2U( substr( cBuffer,  5, 4 ) ) }

*******************************
FUNCTION GetPosAbsoluta( oXbp )
*******************************
LOCAL cBuffer  := Space( 16 )

DllCall("User32.DLL", DLL_STDCALL,"GetWindowRect", oXbp:getHwnd(), @cBuffer )

RETURN { Bin2U( Left( cBuffer, 4 ) ), ;
         AppDeskTop():currentSize()[ 2 ] - Bin2U( substr( cBuffer, 13, 4 ) ) }
