/****************************************************
*
*     PROYECTO: XbpBrowseDragDrop
*     ARCHIVOS: DragBro.dll, DragBro.lib, DragBro.ch,
                DragBro.arc, Sin.ico, Puntero.ico
*
*  Programador: J.A. Diego Kerejeta
*       Creado: 18/09/03
*      Version: 1.0
*
******************************************************/

#include "Appevent.ch"
#include "Directry.ch"
#include "Common.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include 'dll.ch'

#pragma Library( "XppUi2.lib" )

#define COL_SELECTOR_SIN         0
#define COL_SELECTOR_FILAS       1
#define COL_SELECTOR_COLUMNAS    2 

#xtrans  PRESPARAM_BRO  => {;
         { XBP_PP_COL_DA_FGCLR            , GRA_CLR_BLACK                   }, ;
         { XBP_PP_COL_DA_BGCLR            , COLOR_BG_TABLA                  }, ;
         { XBP_PP_COL_DA_COMPOUNDNAME     , FONT_BASE                       }, ;
         { XBP_PP_COL_DA_ROWSEPARATOR     , XBPLINE_NONE                    }, ;
         { XBP_PP_COL_DA_COLSEPARATOR     , XBPLINE_NONE                    }, ;
         { XBP_PP_COL_DA_FRAMELAYOUT      , XBPFRAME_NONE                   }, ;
         { XBP_PP_COL_DA_CELLFRAMELAYOUT  , XBPFRAME_BOX + XBPFRAME_RAISED  }, ;
         { XBP_PP_COL_DA_HILITEFRAMELAYOUT, XBPFRAME_NONE                   }, ;
         { XBP_PP_COL_DA_HILITE_FGCLR     , GRA_CLR_BLACK                   }, ;
         { XBP_PP_COL_DA_HILITE_BGCLR     , COLOR_BG_ROWTABLA               }, ;
         { XBP_PP_COL_HA_COMPOUNDNAME     , '7.Arial Bold'                  }, ;
         { XBP_PP_COL_HA_FGCLR            , COLOR_FG_CABTABLA               }, ;
         { XBP_PP_COL_HA_BGCLR            , COLOR_BG_CABTABLA               } }


#define FONT_BASE 			  "8.Arial"

#define COLOR_BG_ROWTABLA   GraMakeRGBcolor( { 249, 234, 181 } )
#define COLOR_BG_TABLA      GraMakeRGBcolor( { 255, 255, 239 } )
#define COLOR_BG_CABTABLA   GraMakeRGBcolor( {   0,   0, 160 } )
#define COLOR_FG_CABTABLA   GraMakeRGBcolor( { 255, 255, 198 } )
#define COLOR_BG_SELECTOR   GraMakeRGBcolor( { 207, 220, 236 } )
#define COLOR_FG_SELECTOR   GRA_CLR_BLACK
#define COLOR_BG_GETFIND    GraMakeRGBcolor( { 220, 235, 223 } )


****************
PROCEDURE AppSys
****************
LOCAL oDlg

oDlg := XbpDialog():new( , , { 0, 0 }, { 790, 600 }, , .F. )
   oDlg:taskList := .T.
   oDlg:border   := XBPDLG_DLGBORDER
   oDlg:title    := "Test Drag&Drop entre Browses y Ventanas"
   oDlg:drawingArea:SetColorBG( XBPSYSCLR_APPWORKSPACE )
   oDlg:create():setFrameState( XBPDLG_FRAMESTAT_MAXIMIZED )

   SetAppFocus( oDlg )
   SetAppWindow( oDlg )
RETURN

**************
PROCEDURE Main
**************
LOCAL oXbp, mp1, mp2, nEvent
LOCAL imax, aStruct, aPP, i
LOCAL  oColumn, nAlias
LOCAL oDlg1, oBrowse1, oDlg2, oBrowse2
LOCAL aSize:= AppDesktop():currentSize()
LOCAL nEspaciado:= aSize[ 1 ] * 0.1 / 3

aSize[ 1 ] *= 0.45
aSize[ 2 ] *= 0.8

   USE lin_alb1 NEW EXCLUSIVE
   nAlias:= select()

   oDlg1 := GuiStdDialog( "DBF: LIN_ALB1 (selector de fila)", ;
                          { nEspaciado, NIL }, aSize  )

   oBrowse1 := XbpBrowseDragDrop():new( oDlg1:drawingArea  )
      oBrowse1:DBF:= nAlias
      oBrowse1:create()

   imax    := lin_alb1->( FCount() )
   aStruct := lin_alb1->( DbStruct() )

   aPP     := { { XBP_PP_COL_HA_CAPTION, "" } }

   aPP[1,2] := 'Recno'
   oColumn  := XbpColumnDragDrop():new( oBrowse1,,,, aPP )
   oColumn:dataLink     := {|| str( Lin_alb1->( Recno() ), 4 ) }
   oColumn:DBF:= nAlias
   oBrowse1:addColumn( oColumn )

   FOR i:=1 TO imax
      IF .NOT. aStruct[i,2] $ "BOVTXYM"
         aPP[1,2] := aStruct[i,1]
         oColumn  := XbpColumnDragDrop():new( oBrowse1,,,, aPP )
         oColumn:dataLink     := EditBlock( aStruct[i,1], 'Lin_alb1' )

         oColumn:DBF:= nAlias
         oBrowse1:addColumn( oColumn )

      ENDIF
   NEXT

   oDlg1:drawingArea:resize := ;
       {|mp1,mp2,obj| obj:childList()[1]:setSize( mp2 ) }


   USE lin_alb2 NEW EXCLUSIVE
   nAlias:= select()

   oDlg2 := GuiStdDialog( "DBF: LIN_ALB2 (selector de celda)", ;
                          { nEspaciado * 2 + aSize[ 1 ], nil }, aSize  )


   oBrowse2 := XbpBrowseDragDrop():new( oDlg2:drawingArea  )
      oBrowse2:nTipoSelector := COL_SELECTOR_COLUMNAS
      oBrowse2:DBF           := nAlias
      oBrowse2:cursorMode    := XBPBRW_CURSOR_CELL
      oBrowse2:nColorBGselec := COLOR_BG_GETFIND
      oBrowse2:create()

   imax    := lin_alb2->( FCount() )
   aStruct := lin_alb2->( DbStruct() )
   aPP     := { { XBP_PP_COL_HA_CAPTION, "" } }

   aPP[1,2] := 'Recno'
   oColumn  := XbpColumnDragDrop():new( oBrowse2,,,, aPP )
   oColumn:dataLink     := {|| str( Lin_alb2->( Recno() ), 4 ) }
   oColumn:DBF:= nAlias
   oBrowse2:addColumn( oColumn )

   FOR i:=1 TO imax
      IF .NOT. aStruct[i,2] $ "BOVTXYM"
         aPP[1,2] := aStruct[i,1]
         oColumn  := XbpColumnDragDrop():new( oBrowse2,,,, aPP )
         oColumn:dataLink     := EditBlock( aStruct[i,1], 'Lin_alb2' )
         oColumn:DBF:= nAlias
         oBrowse2:addColumn( oColumn )
      ENDIF
   NEXT

   oDlg2:drawingArea:resize := ;
       {|mp1,mp2,obj| obj:childList()[1]:setSize( mp2 ) }

   oBrowse1:show()
   oDlg1:show()

   oBrowse2:show()
   oDlg2:show()

   SetAppFocus( oBrowse1 )


////////////////////////////////////////////////////////
// Registramos cada browse como receptor del otro
// Al hacer Drop se ejecutara la Procedure VolcarDatos()
////////////////////////////////////////////////////////

   oBrowse2:registraReceptor( oBrowse1, {|oOut, oIn| VolcarDatos( oOut, oIn ) } )
   oBrowse1:registraReceptor( oBrowse2, {|oOut, oIn| VolcarDatos( oOut, oIn ) } )

   nEvent:= xbe_None


  DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
  ENDDO
QUIT
RETURN

**********************************
PROCEDURE VolcarDatos( oOut, oIn )
**********************************
LOCAL nRecno := ( oOut:DBF )->( Recno() )
LOCAL nFor, nNumSeleccionados, nCont, nIni, nFin, nPrimerRecno


IF oOut:aRecnos <> nil
   nNumSeleccionados:= LEN( oOut:aRecnos )

   FOR nFor:= 1 TO nNumSeleccionados
      ( oOut:DBF )->( DBgoTo( oOut:aRecnos[ nFor ] ) )
      ( oIn:DBF  )->( DBappend() )
      IF nPrimerRecno = nil
         nPrimerRecno:= ( oIn:DBF )->( Recno() )
      ENDIF
      IF oOut:nTipoSelector == COL_SELECTOR_FILAS
         nIni := 2 
         nFin := oOut:colCount
      ELSE
         nIni := Max( 2, oOut:aCols[ 1 ] )
         nFin := oOut:aCols[ LEN( oOut:aCols ) ]
      ENDIF
      FOR nCont:= nIni TO nFin
         EVAL( oIn:getColumn( nCont ):datalink, EVAL( oOut:getColumn( nCont ):datalink ) )
      NEXT
   NEXT
   ( oOut:DBF )->( DBgoTo( nRecno ) )
   ( oIn:DBF  )->( DBgoTo( nPrimerRecno ) )
   oIn:refreshAll()
ENDIF
RETURN


******************************************************************
* Create std dialog window hidden
******************************************************************
FUNCTION GuiStdDialog( cTitle, aPos, aSize )
   LOCAL oDlg

aPos[ 2 ]:=  CenterPos( aSize, AppDesktop():currentSize() )[ 2 ]

   oDlg          := XbpDialog():new( AppDeskTop(), SetAppWindow(), aPos, aSize,, .F. )
   oDlg:icon     := 1
   oDlg:taskList := .T.
   oDlg:title    := cTitle
   oDlg:drawingArea:ClipChildren := .T.
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( FONT_DEFPROP_SMALL )
 
RETURN oDlg
 

FUNCTION CenterPos( aSize, aRefSize )
RETURN { Int( (aRefSize[1] - aSize[1]) / 2 ) ;
      , Int( (aRefSize[2] - aSize[2]) / 2 ) }


******************************************************************
* Data code block for fields 
******************************************************************
FUNCTION EditBlock( cFieldName, cAlias )
   LOCAL bBlock, cBlock
   IF ( cAlias )->( FieldPos( cFieldName ) ) <> 0
      cFieldName := cAlias + '->' + cFieldName

      cBlock := "{|x| IIf(x==NIL,"+cFieldName+",WriteField('"+cFieldName+"',x) ) }" 
      bBlock := &cBlock
   ENDIF
RETURN bBlock


**********************
* Write value to field
**********************
FUNCTION WriteField( cField, xValue )
   &cField := xValue
RETURN xValue

